#include <iostream>
using namespace std;
int main(){
long long a,b,c,d,e,kutiq=0;
cin>>a>>b>>c>>d>>e;
if(a<b)swap(a,b);
if(a<c)swap(a,c);
if(a<d)swap(a,d);
if(b<c)swap(b,c);
if(b<d)swap(b,d);
if(c<d)swap(c,d);
long long obsto=a*a*a+b*b*b+c*c*c+d*d*d;
if(a+b<=e && a+c<=e && obsto<=e*e*e)
{
    cout<<1;
}
else
{
    if(obsto>e*e*e)
    {
        if(obsto%(e*e*e)==0)
        cout<<obsto/(e*e*e);
        else
              cout<<obsto/(e*e*e)+1;
    }
    else
        if((e*e*e)>=obsto)
    {
        if((e*e*e)%obsto==0)
            cout<<(e*e*e)/obsto;
        else
            cout<<(e*e*e)/obsto+1;
    }
}
return 0;
}